

//'Better Solid Names" - a simple script for renaming solids in an After Effects project to show their dimensions.
//Created by CRGreen, suggested by someone on aenhancers.com

scriptVer = ".9";

function buildSolidRenamerUI(this_obj_) {
    var solidRenameWin = (this_obj_ instanceof Panel)
    ? this_obj_
    : new Window('palette', ('Better Solid Names (Version ' + scriptVer + ")"),[273,205,707,427]);
    solidRenameWin.ctl_button5 = solidRenameWin.add('button', [262,179,396,208], 'Rename Now');
    solidRenameWin.ctl_button5.onClick = function () { mainSolidRename(solidRenameWin) ; this.parent.close(1);}
    solidRenameWin.cancB = solidRenameWin.add('button', [262-66,179,262-66+44,208], 'Close');
    solidRenameWin.cancB.onClick = function () { this.parent.close(0);}
    
    solidRenameWin.useSelRadio = solidRenameWin.add('radiobutton', [33,22,329,44], 'Work on solids in selected project items');
    solidRenameWin.useSelRadio.value = true;
    solidRenameWin.doAllRadio = solidRenameWin.add('radiobutton', [33,52,329,74], 'Search for and work on all solids in project');
    solidRenameWin.doAllRadio.value = false;
    solidRenameWin.appendCheck = solidRenameWin.add('checkbox', [33,92,423,114], 'Append dimensions to existing names instead of replacing names');
    solidRenameWin.appendCheck.value = true;
    solidRenameWin.ctl_label5 = solidRenameWin.add('statictext', [44,136,234,156], 'Use this between dimensions:');
    solidRenameWin.ctl_label5.justify = 'right';
    solidRenameWin.dimensSep = solidRenameWin.add('edittext', [237,130,307,152], 'x');
    solidRenameWin.dimensSep.justify = 'left';
    
    return solidRenameWin
}
var solidRenameW = buildSolidRenamerUI(this);
if (solidRenameW.toString() == "[object Panel]") {
    solidRenameW;
} else {
    solidRenameW.show();
}

function mainSolidRename(w) {
    useSel = w.useSelRadio.value;
    useAppend = w.appendCheck.value;
    dimSep = w.dimensSep.text;
    var everyItem = app.project.items;
    
    var s = [null];
    
    for (var i = everyItem.length; i >= 1; i--) {
        eyeTem = everyItem[i];
        
        if (useSel) {//now unifying, selection or all
            if (eyeTem.selected) {
                s[s.length] = eyeTem;
            }
        }else{
            s[s.length] = eyeTem;
        }
    }    
    
    if (s.length < 2) {
        alert("Not enough solids to work on.");
    }else{
        var selNum = s.length;
        
        app.beginUndoGroup("solid renaming");
        for (var i = s.length; i >= 1; i--) {//loop thru all p items
            thisOne = s[i];
            if ( checkIfSolid(thisOne) ) {
                renameIt(thisOne, useAppend, dimSep);
            }           
        }
        app.endUndoGroup();
    }
}

function renameIt(pItemToChange, appendIt, dimSep) {
    itsWidth = pItemToChange.width;
    itsHeight = pItemToChange.height;
    if (appendIt) {
        pItemToChange.name = ( pItemToChange.name + "_" + itsWidth.toString() + dimSep + itsHeight.toString() );
    }else{
        pItemToChange.name = ( itsWidth.toString() + dimSep + itsHeight.toString() );
    }
}

function checkIfSolid(pItem) {
    if (pItem instanceof FootageItem) {
        if (pItem.mainSource instanceof SolidSource ) {
            return true;
        }else{
            return false;
        }
    }else{
        return false;
    }
}